import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_markdown/flutter_markdown.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:syntax_highlighter/syntax_highlighter.dart' show
SyntaxHighlighterStyle,DartSyntaxHighlighter;

class Markview extends StatelessWidget {
  ScrollController scrollController;
  TextEditingController controller;

  Markview({@required this.scrollController,
    @required this.controller});

  @override
  Widget build(BuildContext context) {
    return Markdown(
      syntaxHighlighter: _My(),
      data: controller.text,
      controller: scrollController,
      styleSheet: MarkdownStyleSheet(
        p:GoogleFonts.openSans(fontSize: 18,height:1.7,color: Colors.black),
        checkbox:GoogleFonts.openSans(fontSize: 18,height:1.7,),
        h1:GoogleFonts.roboto(fontSize: 40,fontWeight: FontWeight.bold,),
        h2: GoogleFonts.roboto(fontSize: 30,fontWeight: FontWeight.bold),
        code: GoogleFonts.lato(fontSize: 18,backgroundColor: Colors.grey[300],height: 1.5),
        codeblockPadding: EdgeInsets.only(left: 20,top: 2,bottom: 2),
        blockquote:GoogleFonts.lato(fontSize: 15,color: Colors.grey[700]),
        blockquoteDecoration:BoxDecoration(
          color: Colors.grey[100],
          border: Border(left: BorderSide(color: Colors.grey[400],width: 3)),
        ) ,
        codeblockDecoration:  BoxDecoration(
          color: Color.fromRGBO(31, 41, 55, 1),
          borderRadius: BorderRadius.circular(8),


        ),




      ),

    );
  }
}

class _My extends SyntaxHighlighter {

  @override
  TextSpan format(String source) {
    return TextSpan(
        style: GoogleFonts.droidSansMono(fontSize: 15,height: 1.5),
        children: [ DartSyntaxHighlighter(SyntaxHighlighterStyle.darkThemeStyle()).format(source)]
    );
    // TODO: implement format
    throw UnimplementedError();
  }

}
