
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_markdown/flutter_markdown.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:markdowneditor/package/markview.dart';
import 'package:markdowneditor/package/tfunction.dart';
import 'package:markdowneditor/package/type.dart';
import 'package:syntax_highlighter/syntax_highlighter.dart' show
SyntaxHighlighterStyle,DartSyntaxHighlighter;

class Mtext extends StatefulWidget {
  TextEditingController controller;
  Size size;
  int maxline;

  Mtext(this.controller,this.size,);

  @override
  _MtextState createState() => _MtextState();
}

class _MtextState extends State<Mtext> with SingleTickerProviderStateMixin{
  int index = 0;

  TextEditingController controller ;
  ScrollController scrollController = ScrollController();
  AnimationController animationController ;
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.all(8.0),
      child: Container(
        child: Column(
          children: [
            Container(
              height: 50,
              decoration: BoxDecoration(
                  color: Colors.grey[100],
                  border: Border.all(color: Colors.grey[200]),
                  borderRadius: BorderRadius.circular(5)
              ),
              child: Padding(
                padding: const EdgeInsets.all(8.0),
                child: ListView(
                  scrollDirection: Axis.horizontal,
                  children: [
                    bicon('write', 0, Icon(Icons.edit,size: 20, color: index==0?Colors.blue:Colors.black45)),
                    SizedBox(width: 5,),
                    InkWell(
                        onTap: (){
                          setState(() {
                            if(index==0){
                              index =1;
                            }else{
                              index =0;
                            }
                          });
                        },
                        child: Icon(Icons.remove_red_eye_sharp,color: index==1?Colors.blue:Colors.black45)),
                    SizedBox(width: 10,),
                    icon(type: MarkType.H1,s: 'H1'),
                    SizedBox(width: 15,),
                    icon(type: MarkType.H2,s: 'H2'),
                    SizedBox(width: 15,),
                    icon(type: MarkType.bold,s: 'B'),
                    SizedBox(width: 15,),
                    icon(type: MarkType.italic,s: 'I'),
                    SizedBox(width: 15,),
                    icon(type: MarkType.quote,icon: Icon(Icons.format_quote)),
                    SizedBox(width: 15,),
                    icon(type: MarkType.code,icon: Icon(Icons.code)),
                    SizedBox(width: 15,),
                    icon(type: MarkType.link,icon: Icon(Icons.link)),
                    SizedBox(width: 15,),
                    icon(type: MarkType.image,icon: Icon(Icons.image_outlined)),
                    SizedBox(width: 15,),
                    icon(type: MarkType.list,icon: Icon(Icons.list)),
                    SizedBox(width: 5,),
                    icon(type: MarkType.check,icon: Icon(Icons.check_box_rounded,color: Colors.grey[700],)),
                    SizedBox(width: 15,),
                    icon(type: MarkType.uncheck,icon: Icon(Icons.check_box_outline_blank)),
                    SizedBox(width: 5,),

                  ],
                ),
              ),
            ),
            Expanded(
              child: Container(
                child: Scrollbar(
                  controller: scrollController,
                  child: index==0? Container(
                    child: Padding(
                      padding: const EdgeInsets.only(left: 8,right: 8),
                      child: TextField(
                        scrollPhysics: BouncingScrollPhysics(),
                        decoration: InputDecoration(
                            border: InputBorder.none
                        ),
                        controller: controller,
                        style: TextStyle(fontSize: 20),
                        textInputAction: TextInputAction.newline,
                        textCapitalization: TextCapitalization.sentences,
                        maxLines: 100,
                        scrollController:scrollController ,


                      ),
                    ),
                  ):
                  Container(
                      height: widget.size.height,
                      child: Scrollbar(
                        controller: scrollController,
                        child: Markview(
                          scrollController: scrollController,
                          controller: controller,
                        )
                      )
                  ),
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }

  Widget bicon(String s, int i, Icon icon){
    return FlatButton.icon(onPressed: (){
      setState(() {
        index = i;
      });
    },
        shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(5)
        ),
        icon: icon, label: Text(s,style: TextStyle(
            fontSize: 17,fontWeight: FontWeight.w600,
            color: index==i?Colors.blue:Colors.black45
        ),));
  }
  Widget icon({MarkType  type,String s,Icon icon }){
    return  InkWell(
        onTap: (){
          Tfunction(type: type,controller: controller).edittext();
          setState(() {});
        },
        child:s!=null?Center(child: Text(s,style: GoogleFonts.ubuntu(fontSize: 17),)): icon);
  }
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    animationController = AnimationController(vsync: this);
    controller=widget.controller;

  }
}

class _My extends SyntaxHighlighter {

  @override
  TextSpan format(String source) {
    return TextSpan(
        style: GoogleFonts.droidSansMono(fontSize: 13,height: 1.5),
        children: [ DartSyntaxHighlighter(SyntaxHighlighterStyle.darkThemeStyle()).format(source)]
    );
    // TODO: implement format
    throw UnimplementedError();
  }

}
